#include "include/encoder.hpp"
#include "include/mathUtils.hpp"
#include "include/spi.hpp"

std::vector<int32_t> Encoder::read_all() {
    std::vector<int32_t> result;
    uint8_t result_bytes[ENCODER_COUNT * 4] = {0};

    Spi::getInstance().read_array(Spi::Register::MOTOR_1_POS_B3, ENCODER_COUNT * 4, result_bytes);

    for (int i = 0; i < ENCODER_COUNT; i++) {
        result.push_back(mathUtils::int_from_bytes(result_bytes + i * ENCODER_COUNT, 4));
    }
    return result;
}